#include <cstdlib>
#include <iostream>
#include <fstream>
#include <stdio.h>
#include <cstring>
#include <string.h>
#include <time.h>

#include "triangulation.h"
#include "debug.h"

using namespace std;
//using namespace ami;

imageBMP draw(NodeTree &nT,triangulation &T0, triangulation &T,bool draw_nodes=true){

  imageBMP I(1024,1024,color( (unsigned char) 255));
  int width=I.width();
  int height=I.height();
if(true){
  for(int m=0;m<I.size();m++) I[m]=color((unsigned char) 230);
  #pragma omp parallel for
  for(int x=0;x<width;x++){
    for(int y=0;y<height;y++){
       point2d v((float) x,(float) y);
       for(unsigned int k=0;k<T0.t.size();k++){
         float R1,R2,R3;
         R1=R(T0.p[T0.t[k].v[0]],T0.p[T0.t[k].v[1]],v);
         R2=R(T0.p[T0.t[k].v[1]],T0.p[T0.t[k].v[2]],v);
         R3=R(T0.p[T0.t[k].v[2]],T0.p[T0.t[k].v[0]],v);
         if( (R1>=0 && R2>=0 && R3>=0) || (R1<=0 && R2<=0 && R3<=0) ){
           I[y*width+x]=color((unsigned char) 255);
           break;
         }
       }
   }

 }
}
  vector<color> col(T.t.size());
  for(unsigned int k=0;k<col.size();k++) col[k]=color((unsigned char) (rand()%256),(unsigned char) (rand()%256),(unsigned char) (rand()%256));
//  #pragma omp parallel for
  for(int x=0;x<width;x++){
    for(int y=0;y<height;y++){
      point2d v((float) x,(float) y);
      for(unsigned int k=0;k<T.t.size();k++){
        float R1,R2,R3;
        R1=R(T.p[T.t[k].v[0]],T.p[T.t[k].v[1]],v);
        R2=R(T.p[T.t[k].v[1]],T.p[T.t[k].v[2]],v);
        R3=R(T.p[T.t[k].v[2]],T.p[T.t[k].v[0]],v);
        if( (R1>=0 && R2>=0 && R3>=0) || (R1<=0 && R2<=0 && R3<=0) ){
          I[y*width+x]=color((unsigned char) 0,(unsigned char) 0,(unsigned char) 255);  //col[k]; //color((unsigned char) ((64*k)%255),(unsigned char) ((10*(k+2))%255),(unsigned char)(150*(k+1))%255);
          break;
        }
      }
    }
  }
  if(draw_nodes==false) return I;


  int r=9;
  for(unsigned int k=0;k<nT.n_.size();k++){
  int x=round(nT.n_[k].x);
  int y=round(nT.n_[k].y);
  for(int i=-r;i<=r;i++){
    for(int j=-r;j<=r;j++){
      if((i*i+j*j)>(r*r)) continue;
        I[(i+x+I.width()*(j+y))%I.size()]=k>0?color((unsigned char) 0):color((unsigned char) 0,(unsigned char) 0,(unsigned char) 0);
      }
    }
  }

  for(unsigned int k=0;k<nT.i_.size();k++){
    for(unsigned int j=0;j<nT.i_[k].size();j++){
      for(float w=0.;w<1.;w+=0.0025){
        point2d p2d=nT.n_[k]*w+nT.n_[nT.i_[k][j]]*(1.-w);
        int x=round(p2d.x);
        int y=round(p2d.y);
        I[(x+I.width()*y)%I.size()]=color((unsigned char) 0);
      }
    }
  }

  /// WE DRAW THE CIRCLES WITH NODE WIDTH RADIUS
  for(unsigned int k=0;k<nT.n_.size();k++){
    //printf("nT.r_[%d]=%lf\n",k,nT.r_[k]); system("pause");
    int x=round(nT.n_[k].x);
    int y=round(nT.n_[k].y);
    for(double angle=0;angle<2*M_PI;angle+=0.025){
      int i=x+nT.r_[k]*cos(angle);
      int j=y+nT.r_[k]*sin(angle);
        I[(i+I.width()*j)%I.size()]=color((unsigned char) 0);
    }
  }

  /// WE DRAW THE POINT TO BE CONNECTED
  for(unsigned int k=0;k<nT.n_.size();k++){
    for(unsigned int m=0;m<nT.i_[k].size();m++){
      point2d pk1,pk2;
      double ak1,ak2,zmin=0.7;
      if(nT.a_[k].size()==1){
          ak1 = nT.a_[k][0]+M_PI*0.5;
          pk1 = nT.n_[k]+point2d(cos(ak1),sin(ak1))*nT.r_[k];
          ak2 = nT.a_[k][0]-M_PI*0.5;
          pk2 = nT.n_[k]+point2d(cos(ak2),sin(ak2))*nT.r_[k];
      }
      else{
        int m1=(m+1)%nT.a_[k].size();
        ak1=angle_average(nT.a_[k][m],nT.a_[k][m1]);
        double z=fabs(sin(0.5*angle_dif(nT.a_[k][m],nT.a_[k][m1])));
        if(nT.s_[k]<0.001) pk1 = nT.n_[k]+point2d(cos(ak1),sin(ak1))*nT.r_[k]/z;
        else{
          z=sqrt(z);
          pk1 = nT.n_[k]+point2d(cos(ak1),sin(ak1))*nT.r_[k]/(z<zmin?zmin:z);
        }
        m1=m==0?nT.a_[k].size()-1:m-1;
        ak2=angle_average(nT.a_[k][m1],nT.a_[k][m]);
        //z=sqrt(fabs(sin(0.5*angle_dif(a_[k][m1],a_[k][m]))));
        z=fabs(sin(0.5*angle_dif(nT.a_[k][m1],nT.a_[k][m])));
        if(nT.s_[k]<0.001)  pk2 = nT.n_[k]+point2d(cos(ak2),sin(ak2))*nT.r_[k]/z;
        else{
          z=sqrt(z);
          pk2 = nT.n_[k]+point2d(cos(ak2),sin(ak2))*nT.r_[k]/(z<zmin?zmin:z);
        }
      }
      /// WE DRAW THE SEGMENT JOINING THE NODE AND THE POINTS
      for(float w=0.;w<1.;w+=0.01){
        point2d p2d=nT.n_[k]*w+pk1*(1.-w);
        int x=round(p2d.x);
        int y=round(p2d.y);
        I[(x+I.width()*y)%I.size()]=color((unsigned char) 0,(unsigned char) 255,(unsigned char) 0);
        p2d=nT.n_[k]*w+pk2*(1.-w);
        x=round(p2d.x);
        y=round(p2d.y);
        I[(x+I.width()*y)%I.size()]=color((unsigned char) 0,(unsigned char) 255,(unsigned char) 0);
      }
      /// WE DRAR CIRCLES IN THE CONNECTION POINTS
      r=6;
      for(int i=-r;i<=r;i++){
        for(int j=-r;j<=r;j++){
          if((i*i+j*j)>(r*r)) continue;
          int x=round(pk1.x+i); int y=round(pk1.y+j);
          //printf("i=%d j=%d x=%d y=%d\n",i,j,x+i,y+j);
          if(x>=0 && x<I.width() && y>=0 && y<I.height())
            I[(x+I.width()*(y))%I.size()]=color((unsigned char) 0,(unsigned char) 255,(unsigned char) 0);
          x=round(pk2.x+i); y=round(pk2.y+j);
          //printf("i=%d j=%d x=%d y=%d\n",i,j,x+i,y+j);
          if(x>=0 && x<I.width() && y>=0 && y<I.height())
            I[(x+I.width()*(y))%I.size()]=color((unsigned char) 0,(unsigned char) 255,(unsigned char) 0);
        }
      }
    }
  }




  return I;

}


void writeTriangulationBMP(triangulation &T,char name[200]){
  imageBMP Iz(1024,1024,color((unsigned char) 255));
  int width=Iz.width();
  int height=Iz.height();
  vector<color> col(T.t.size());
  for(unsigned int k=0;k<col.size();k++) col[k]=color((unsigned char) (rand()%256),(unsigned char) (rand()%256),(unsigned char) (rand()%256));
  for(int x=0;x<width;x++){
    for(int y=0;y<height;y++){
        Iz[y*width+x]=color((unsigned char) 255,(unsigned char)255,(unsigned char)255);
        point2d v((float) x,(float) y);
        for(unsigned int k=0;k<T.t.size();k++){
          float R1,R2,R3;
          R1=R(T.p[T.t[k].v[0]],T.p[T.t[k].v[1]],v);
          R2=R(T.p[T.t[k].v[1]],T.p[T.t[k].v[2]],v);
          R3=R(T.p[T.t[k].v[2]],T.p[T.t[k].v[0]],v);
          if( (R1>=0 && R2>=0 && R3>=0) || (R1<=0 && R2<=0 && R3<=0) ){
            Iz[y*width+x]=col[k]; //color((unsigned char) ((64*k)%255),(unsigned char) ((10*(k+2))%255),(unsigned char)(150*(k+1))%255);
            break;
          }
        }
    }
  }
  Iz.write(name);
}

void fprintf_demo_failure(char mes[300]){
  FILE * f;
  f = fopen ("demo_failure.txt", "w");
  if(f==NULL){
    printf("We can not open demo_failure.txt");
    return;
  }
  fprintf(f,"%s\n",mes);
  fclose(f);
  return;
}

point2d find_point_triangulation_1024x1024(triangulation &Tinit){
  point2d p0;
  while(true){
    p0.x=rand()%1024;
    p0.y=rand()%1024;
    //printf("%d ",Tinit.inclusion_test(p0));
    if( Tinit.inclusion_test(p0)>=0) break;
  }
  return p0;
}


/// **********************************************************************************
/// ******* GENERATOR OF BRANCHED SHAPES **************************************
/// **********************************************************************************
NodeTree BranchedShapeGenerator(
triangulation &Tinit,
int shape_type,
int random_seed,
float average_node_distance,
float average_radius,
float smoothing_factor,
int branched_finished_in_peak,
float joint_extrema_probability,
int MaxNeigbors,
bool allow_branche_intersection,
float node_radius_reduction_factor,
int MaxAngles
)
{

  /// CHECKING PARAMETERS
  if(shape_type<0 || shape_type>10){
    char mes[300];
    sprintf(mes,"The shape type (%d) is out of range [0,10]\n",shape_type+1);
    printf("%s\n",mes);
    fprintf_demo_failure(mes);
    return NodeTree();
  }
  if(shape_type!=1 && smoothing_factor<0.001) smoothing_factor=0.001;

  /// NORMALIZATION OF THE NODE DISTANCE
  average_node_distance/=150.;

  /// NODE TREE STRUCTURE
  NodeTree nT;

  /// AUXILIARY VARIABLES
  float node_radius_reduction_factor_sqrt=sqrt(node_radius_reduction_factor);
  srand(random_seed); rand();
  bool round_termination = branched_finished_in_peak==0?true:false;
  float zoom=average_node_distance; //0.1+myrand(1.)*0.9;
  float dmin=64.;
  float R0=512-dmin;
  int type=0;
  int Nbranches=100000;
  float gamma=1.;
  unsigned int MaxNnodes=100000;

  ///-------------------------------------------------------------------------------------------------------
  /// MATISSE 13 GENERATION FROM A CENTRAL POINT
  if(shape_type==0) //AAA
  {
    if(Tinit.p.size()==0){
      /// BUILD A DECAGON TO CONSTRAINT THE SHAPE
      float T0y[5]={R0*sinf(2*M_PI/5),R0*sinf(M_PI/5),0,-R0*sinf(M_PI/5),-R0*sinf(2*M_PI/5)};
      float T0R[5]={R0*cosf(2*M_PI/5),R0*cosf(M_PI/5),R0,R0*cosf(M_PI/5),R0*cosf(2*M_PI/5)};
      Tinit=triangulation(point2d(512.,512.),T0y,T0R);
    }

    /// INSERT THE FIRST NODE IN THE TREE
    point2d p0=find_point_triangulation_1024x1024(Tinit);
    nT.n_.push_back(p0);
    nT.i_.resize(1);
    nT.r_.push_back(average_radius*1.5*zoom);
    nT.s_.push_back(0.75);

    /// DEFINE VARIABLES FOR THE TREE GENERATION
    float min_segment_length=200.*zoom,max_segment_length=250.*zoom;
    float distance_segment_factor=2.5;
    float min_radius=average_radius*zoom,max_radius=min_radius*6./5.;
    float distance_node_factor=5.;
    if(allow_branche_intersection==true){
      min_segment_length=175.*zoom;
      max_segment_length=275.*zoom;
      distance_node_factor=4.;
    }
    float smy=myrand(1.);
    distance_node_factor*=pow(node_radius_reduction_factor,0.5+5.*smy);
    distance_segment_factor*=pow(node_radius_reduction_factor,0.5+1.*smy);
    vector<double> angles=nT.angle_range(100);
    if(MaxAngles<(int) angles.size()){
      if(rand()%10==0) angles.resize(MaxAngles);
      else  angles=nT.angle_range_rand(MaxAngles);
    }


    int cont=0;
    while(true){
      cont++;
      int Nnodes=nT.n_.size();
      min_segment_length*=node_radius_reduction_factor;
      max_segment_length*=node_radius_reduction_factor;
      min_radius*=node_radius_reduction_factor;
      max_radius*=node_radius_reduction_factor;
      if(min_radius<1. || min_segment_length<2.) break; //min_radius=1;
      distance_segment_factor/=node_radius_reduction_factor_sqrt;
      distance_node_factor/=node_radius_reduction_factor;

      float gamma2=gamma;
      bool allow_branche_intersection2=false;
      float min_segment_length2=min_segment_length;
      float max_segment_length2=max_segment_length;
      float distance_node_factor2=distance_node_factor;
      int MaxNeigbors2=MaxNeigbors;
      if(allow_branche_intersection==true){
        distance_node_factor2*=1.8/pow(node_radius_reduction_factor,1.);
        if(cont%2==0){
          gamma2=1.;
          allow_branche_intersection2=true;
          min_segment_length2=max_segment_length;
          max_segment_length2*=1.2;
          MaxNeigbors2=3;
        }
      }

      nT.insert_nodes(
        Tinit,
        min_segment_length2,
        max_segment_length2,
        distance_segment_factor,
        min_radius,max_radius,
        distance_node_factor2,
        smoothing_factor,
        type,
        gamma2,
        1,// Nbranches,
        angles,
        MaxNnodes,
        MaxNeigbors2,
        allow_branche_intersection2
      );
      if(Nnodes==(int) nT.n_.size()) break;
    }
#ifdef DEBUG
if(nT.checking()==false){
    printf("checking fails before joint_extrema()\n");
    char filename[400]="nT.txt";
    nT.write(filename);
    system("pause");
}
#endif


    nT.joint_extrema(joint_extrema_probability);



#ifdef DEBUG
if(nT.checking()==false){
    printf("checking fails after joint_extrema()\n");
    char filename2[400]="nT2.txt";
    nT.write(filename2);
    system("pause");
}
#endif

    if(round_termination==false){
      for(unsigned int k=0;k<nT.n_.size();k++){
        if(nT.i_[k].size()==1) {
          nT.r_[k]=1;
          nT.s_[k]=0.1;
          nT.n_[k]=nT.n_[nT.i_[k][0]]+(nT.n_[k]-nT.n_[nT.i_[k][0]])*0.75;
        }
      }
    }
    nT.normalize();
  }

  ///-------------------------------------------------------------------------------------------------------
  /// MATISSE 11 LABERINTHIC
  else if(shape_type==1)
  {
    if(Tinit.p.size()==0){
      /// BUILD A DECAGON TO CONSTRAINT THE SHAPE
      float T0y[5]={R0*sinf(2*M_PI/5),R0*sinf(M_PI/5),0,-R0*sinf(M_PI/5),-R0*sinf(2*M_PI/5)};
      float T0R[5]={R0*cosf(2*M_PI/5),R0*cosf(M_PI/5),R0,R0*cosf(M_PI/5),R0*cosf(2*M_PI/5)};
      Tinit=triangulation(point2d(512.,512.),T0y,T0R);
    }

    /// INSERT THE FIRST NODE IN THE TREE
    point2d p0=find_point_triangulation_1024x1024(Tinit);
    nT.n_.push_back(p0);
    nT.i_.resize(1);
    nT.r_.push_back(zoom*average_radius);
    nT.s_.push_back(smoothing_factor);

    /// DEFINE VARIABLES FOR THE TREE GENERATION
    float min_segment_length=200.*zoom,max_segment_length=200.*zoom;
    float distance_segment_factor=2.5;
    float min_radius=zoom*average_radius,max_radius=zoom*average_radius;
    float distance_node_factor=5.;
    if(allow_branche_intersection==true){
      min_segment_length=175.*zoom;
      max_segment_length=275.*zoom;
      distance_node_factor=4.;
    }
    float smy=myrand(1.);
    distance_node_factor*=pow(node_radius_reduction_factor,0.5+2.*smy);
    distance_segment_factor*=pow(node_radius_reduction_factor,0.5+1.*smy);

    /// DEFINE THE INITIAL VECTOR OF DIRECTIONS
    vector<double> angles;
    angles.push_back(0.);
    angles.push_back(M_PI/2);
    angles.push_back(M_PI);
    angles.push_back(3*M_PI/2);
    angles.push_back(M_PI/4);
    angles.push_back(3*M_PI/4);
    angles.push_back(5*M_PI/4);
    angles.push_back(7*M_PI/4);
    int c=rand()%3;
    if(MaxAngles==4 || ( MaxAngles>8 && c==0 ) ){
      angles.resize(4);
    }
    else if(MaxAngles==3 || ( MaxAngles>8 && c==1 ) ){
      angles.resize(3);
      angles[1]=2.*M_PI/3.;
      angles[2]=4.*M_PI/3.;
    }
    else if(MaxAngles<8){
      angles.resize(MaxAngles);
    }
    /// INCLUSION OF NODES IN THE TREE
    int cont=0;
    while(true){
    cont++;
    int Nnodes=nT.n_.size();
    min_segment_length*=node_radius_reduction_factor;
    max_segment_length*=node_radius_reduction_factor;
    min_radius*=node_radius_reduction_factor;
    max_radius*=node_radius_reduction_factor;
    if(min_radius<1. || min_segment_length<2.) break; //min_radius=1;
    distance_segment_factor/=node_radius_reduction_factor_sqrt;
    distance_node_factor/=node_radius_reduction_factor;

    float gamma2=gamma;
    bool allow_branche_intersection2=false;
    float min_segment_length2=min_segment_length;
    float max_segment_length2=max_segment_length;
    float distance_node_factor2=distance_node_factor;
    int MaxNeigbors2=MaxNeigbors;
    if(allow_branche_intersection==true){
      distance_node_factor2*=1.8/pow(node_radius_reduction_factor,1.5);
      if(cont%2==0){
        gamma2=1.;
        allow_branche_intersection2=true;
        min_segment_length2=max_segment_length;
        max_segment_length2*=1.2;
        MaxNeigbors2=3;
      }
    }

    nT.insert_nodes(
      Tinit,
      min_segment_length2,
      max_segment_length2,
      distance_segment_factor,
      min_radius,max_radius,
      distance_node_factor2,
      smoothing_factor,
      type,
      gamma2,
      1,// Nbranches,
      angles,
      MaxNnodes,
      MaxNeigbors2,
      allow_branche_intersection2
    );
    if(Nnodes==(int) nT.n_.size()) break;
    }

    nT.joint_extrema(joint_extrema_probability);
    nT.normalize();
  }

  ///-------------------------------------------------------------------------------------------------------
  /// MATISSE 12 RANDOM DISTRIBUTION
  else if(shape_type==2)
  {
    if(Tinit.p.size()==0){
      /// BUILD A DECAGON TO CONSTRAINT THE SHAPE
      float T0y[5]={R0*sinf(2*M_PI/5),R0*sinf(M_PI/5),0,-R0*sinf(M_PI/5),-R0*sinf(2*M_PI/5)};
      float T0R[5]={R0*cosf(2*M_PI/5),R0*cosf(M_PI/5),R0,R0*cosf(M_PI/5),R0*cosf(2*M_PI/5)};
      Tinit=triangulation(point2d(512.,512.),T0y,T0R);
    }

     /// INSERT THE FIRST NODE IN THE TREE
     point2d p0=find_point_triangulation_1024x1024(Tinit);

     float min_smooth_factor=0.1+myrand(1.)*0.25*smoothing_factor;
     float max_smooth_factor=smoothing_factor;

     nT.n_.push_back(p0);
     nT.i_.resize(1);
     nT.r_.push_back(zoom*average_radius);
     nT.s_.push_back(min_smooth_factor+myrand(1.)*(max_smooth_factor-min_smooth_factor));

     float min_segment_length=200.*zoom,max_segment_length=250.*zoom;
     float distance_segment_factor=2.;
     float min_radius=20.*zoom*average_radius/50.,max_radius=100*zoom*average_radius/50.;
     float distance_node_factor=4.;
     float max_distance_node_factor=32.;
     if(allow_branche_intersection==true){
       min_segment_length=175.*zoom;
       max_segment_length=275.*zoom;
       distance_node_factor=3.;
     }

     double min_angle_distance=M_PI/16.;
     unsigned int MaxAttempts=1000;
     /// INCLUSION OF NODES IN THE TREE
     nT.random_generation(
       Tinit,
       min_segment_length,max_segment_length,
       distance_segment_factor,
       min_radius,max_radius,
       distance_node_factor,
       max_distance_node_factor,
       min_smooth_factor,max_smooth_factor,
       gamma,
       min_angle_distance,
       MaxNnodes,
       MaxNeigbors,
       MaxAttempts,
       allow_branche_intersection
     );

     nT.joint_extrema(joint_extrema_probability);

     if(round_termination==false){
      for(unsigned int k=0;k<nT.n_.size();k++){
        if(nT.i_[k].size()==1) {
          nT.r_[k]=1;
          nT.s_[k]=0.1;
          nT.n_[k]=nT.n_[nT.i_[k][0]]+(nT.n_[k]-nT.n_[nT.i_[k][0]])*0.75;
        }
      }
    }
  }

  ///-------------------------------------------------------------------------------------------------------
  /// MATISSE 5 SPIDER
  else if(shape_type==3)
  {
      /// BUILD A DECAGON TO CONSTRAINT THE SHAPE
      float T0y[5]={R0*sinf(2*M_PI/5),R0*sinf(M_PI/5),0,-R0*sinf(M_PI/5),-R0*sinf(2*M_PI/5)};
      float T0R[5]={R0*cosf(2*M_PI/5),R0*cosf(M_PI/5),R0,R0*cosf(M_PI/5),R0*cosf(2*M_PI/5)};
      Tinit=triangulation(point2d(512.,512.),T0y,T0R);

      nT.n_.push_back(point2d(512.,512.));
      nT.i_.resize(1);
      nT.r_.push_back(70);
      nT.s_.push_back(smoothing_factor);

      float min_segment_length=200.,max_segment_length=250.;
      float distance_segment_factor=2.;
      float min_radius=30.,max_radius=50.;
      float distance_node_factor=4.;


      Nbranches=1;
      vector<double> angles=nT.angle_range(100);
      if(MaxAngles<(int) angles.size()) angles.resize(MaxAngles);

      if(allow_branche_intersection==true){
        min_segment_length=200.;
        max_segment_length=250.;
        distance_node_factor=4.;
      }

      float smy=myrand(1.);
      distance_node_factor*=pow(node_radius_reduction_factor,0.5+2.*smy);
      distance_segment_factor*=pow(node_radius_reduction_factor,0.5+1.*smy);
      min_radius*=node_radius_reduction_factor;
      max_radius*=node_radius_reduction_factor;

      /// INCLUSION OF NODES IN THE TREE
      nT.insert_nodes(
        Tinit,
        min_segment_length,max_segment_length,
        distance_segment_factor,
        min_radius,max_radius,
        distance_node_factor,
        smoothing_factor,
        type,
        gamma,
        Nbranches,
        angles,
        MaxNnodes,
        MaxNeigbors,
        allow_branche_intersection
     );

     min_radius=3.;max_radius=3;
     distance_segment_factor=20.;
     min_segment_length=200.;
     max_segment_length=250.;
     distance_node_factor=1500.;
     Nbranches=1;
     /// INCLUSION OF NODES IN THE TREE
     nT.insert_nodes(
        Tinit,
        min_segment_length,max_segment_length,
        distance_segment_factor,
        min_radius,max_radius,
        distance_node_factor,
        smoothing_factor,
        type,
        gamma,
        Nbranches,
        angles,
        MaxNnodes,
        2,
        allow_branche_intersection
     );
  }

  ///-------------------------------------------------------------------------------------------------------
  /// MATISSE 6 WATER DROP
  else if(shape_type==4)
  {
      Tinit=triangulation(point2d(0.,0.),point2d(1024.,1024.));

      R0=150+100*myrand(1.);

      nT.clear();

      nT.n_.push_back(point2d(512.,dmin+R0));
      nT.i_.resize(1);
      nT.r_.push_back(R0*average_radius/50);
      nT.s_.push_back(smoothing_factor);

      nT.insert_point( point2d(512.+(-1.+2.*myrand(1.))*30,1024.-dmin) , 1., 0.1, 0);

      vector<double> angles=nT.angle_range(13);
      int posa=myrand(1.)*angles.size();
      posa=posa%angles.size();
      nT.insert_point( nT.n_[1]-point2d(cos(angles[posa]),sin(angles[posa]))*3 , 5., 1., 0,1);
  }

  ///-------------------------------------------------------------------------------------------------------
  /// MATISSE 8 (TREE)
  else if(shape_type==5)
  {
      /// BUILD A DECAGON TO CONSTRAINT THE SHAPE
      float T0y[5]={348.,212.,0.,-238.,-448.};
      float T0R[5]={10.,128.,300.,200.,200};
      Tinit=triangulation(point2d(512.,512.),T0y,T0R);

      float min_segment_length=150.*zoom,max_segment_length=200.*zoom;
      float distance_segment_factor=8.;
      float min_radius=average_radius*zoom,max_radius=average_radius*zoom;
      float distance_node_factor=4.;

      gamma=1.5;
      vector<double> angles=nT.angle_range(3);

      nT.clear();
      nT.n_.push_back(point2d(512.,dmin+30.));
      nT.i_.resize(1);
      nT.r_.push_back(average_radius*zoom);
      nT.s_.push_back(smoothing_factor);

      /// INCLUSION OF NODES IN THE MAIN BRANCHE OF THE TREE
      int cont=0;
      while(true){
        cont++;
        int Nnodes=nT.n_.size();
        average_radius*=node_radius_reduction_factor;
        min_segment_length*=node_radius_reduction_factor;
        max_segment_length*=node_radius_reduction_factor;
        min_radius*=node_radius_reduction_factor;
        max_radius*=node_radius_reduction_factor;
        if(min_radius<1. || min_segment_length<2.) break; //min_radius=1;
        distance_segment_factor/=node_radius_reduction_factor_sqrt;
        distance_node_factor/=node_radius_reduction_factor;

        nT.insert_nodes(
          Tinit,
          min_segment_length,max_segment_length,
          distance_segment_factor,
          min_radius*1.3,max_radius*1.3,
          distance_node_factor,
          smoothing_factor,
          type,
          gamma,
          1,// Nbranches,
          angles,
          MaxNnodes,
          100,
          false //allow_branche_intersection
        );
        if(Nnodes==(int) nT.n_.size()) break;
      }

      /// INCLUSION OF NODES IN THE LATERAL BRANCHES OF THE TREE
      gamma=3;
      Nbranches=1;
      angles=nT.angle_range(15);
      distance_segment_factor=2.5/pow(node_radius_reduction_factor_sqrt,(float) cont);
      min_segment_length=100.*zoom*pow(node_radius_reduction_factor_sqrt,(float) cont);
      max_segment_length=150.*zoom*pow(node_radius_reduction_factor_sqrt,(float) cont);


      /// INCLUSION OF NODES IN THE LATERAL BRANCHES OF THE TREE
      nT.insert_nodes(
        Tinit,
        min_segment_length,max_segment_length,
        distance_segment_factor,
        min_radius,max_radius,
        distance_node_factor,
        smoothing_factor,
        type,
        gamma,
        Nbranches,
        angles,
        MaxNnodes,
        5,
        false //allow_branche_intersection
     );

//     if(allow_branche_intersection==true){
//        min_segment_length=100.*zoom*pow(node_radius_reduction_factor_sqrt,(float) cont);
//        max_segment_length=200.*zoom*pow(node_radius_reduction_factor_sqrt,(float) cont);
//        distance_node_factor=4./pow(node_radius_reduction_factor,(float) cont);
//      }

      Nbranches=10000;
      angles=nT.angle_range(15);
      if(MaxAngles<(int) angles.size()) angles.resize(MaxAngles);
      distance_segment_factor=2.5/pow(node_radius_reduction_factor_sqrt,(float) cont);
      distance_node_factor=5./pow(node_radius_reduction_factor,(float) cont);

      min_segment_length=100.*zoom;
      max_segment_length=150.*zoom;

//      if(allow_branche_intersection==true){
//        min_segment_length=100.*zoom;
//        max_segment_length=250.*zoom;
//        distance_node_factor=3;
//      }

      float smy=myrand(1.);
      distance_node_factor*=pow(node_radius_reduction_factor,0.5+2.*smy);
      distance_segment_factor*=pow(node_radius_reduction_factor,0.5+1.*smy);

      cont=0;
      while(true){
        cont++;
        int Nnodes=nT.n_.size();
        min_segment_length*=node_radius_reduction_factor;
        max_segment_length*=node_radius_reduction_factor;
        min_radius*=node_radius_reduction_factor;
        max_radius*=node_radius_reduction_factor;
        if(min_radius<1. || min_segment_length<2.) break; //min_radius=1;
        distance_segment_factor/=node_radius_reduction_factor_sqrt;
        distance_node_factor/=node_radius_reduction_factor;

        float gamma2=gamma;
        bool allow_branche_intersection2=false;
        float min_segment_length2=min_segment_length;
        float max_segment_length2=max_segment_length;
        float distance_node_factor2=distance_node_factor;
        if(cont%2==0 && allow_branche_intersection==true){
          gamma2=1.;
          allow_branche_intersection2=true;
          min_segment_length2=max_segment_length;
          max_segment_length2*=1.2;
          distance_node_factor2*=1.;
        }

        nT.insert_nodes(
          Tinit,
          min_segment_length2,
          max_segment_length2,
          distance_segment_factor,
          min_radius,max_radius,
          distance_node_factor2,
          smoothing_factor,
          type,
          gamma2,
          1,// Nbranches,
          angles,
          MaxNnodes,
          3,
          allow_branche_intersection2
        );
        if(Nnodes==(int) nT.n_.size()) break;
      }


     nT.joint_extrema(joint_extrema_probability);

     if(round_termination==false){
        for(unsigned int k=0;k<nT.n_.size();k++){
          if(nT.i_[k].size()==1) {
            nT.r_[k]=1;
            nT.s_[k]=0.1;
            nT.n_[k]=nT.n_[nT.i_[k][0]]+(nT.n_[k]-nT.n_[nT.i_[k][0]])*0.75;
          }
        }
      }
      nT.normalize();
  }


  ///-------------------------------------------------------------------------------------------------------
  /// MATISSE 10 SEAWOOD 1
  else if(shape_type==6)
  {
      node_radius_reduction_factor=pow(node_radius_reduction_factor,0.75);
      /// BUILD A DECAGON TO CONSTRAINT THE SHAPE
      float T0y[5]={R0*sinf(2*M_PI/5),R0*sinf(M_PI/5),0,-R0*sinf(M_PI/5),-R0*sinf(2*M_PI/5)};
      float T0R[5]={R0*cosf(2*M_PI/5),R0*cosf(M_PI/5),R0,R0*cosf(M_PI/5),R0*cosf(2*M_PI/5)};
      Tinit=triangulation(point2d(512.,512.),T0y,T0R);

      nT.clear();
      nT.n_.push_back(point2d(512.,512.-0.9*R0));
      nT.i_.resize(1);
      nT.r_.push_back(40*zoom*average_radius/50.);
      nT.s_.push_back(smoothing_factor);

      {

        for(unsigned int k=1;(float) k<4./zoom;k++){
          float scale=1.; //=pow(node_radius_reduction_factor,(float) k-1);
          nT.insert_point(nT.n_[nT.n_.size()-1]+point2d(90.*zoom*scale,myrand(1.)*20*zoom*scale),40.*zoom*scale*average_radius/50.,0.75,nT.n_.size()-1);
          if(nT.n_[nT.n_.size()-1].x-1.2*T0R[4]>512.) break;
        }
        nT.insert_point(nT.n_[0]+point2d(-90.*zoom,myrand(1.)*20*zoom),40.*zoom*average_radius/50.,0.75,0);
        for(unsigned int k=2;(float) k<4./zoom;k++){
          float scale=1.; //pow(node_radius_reduction_factor,(float) k-2);
          nT.insert_point(nT.n_[nT.n_.size()-1]+point2d(-90.*zoom*scale,myrand(1.)*20*zoom*scale),40.*zoom*scale*average_radius/50.,0.75,nT.n_.size()-1);
          if(nT.n_[nT.n_.size()-1].x+T0R[4]*1.2<512.) break;
        }
      }

      float min_segment_length=100.*zoom,max_segment_length=150.*zoom;
      float distance_segment_factor=2.;
      float min_radius=30.*zoom*average_radius/50.,max_radius=40*zoom*average_radius/50.;
      float distance_node_factor=4.;
      if(allow_branche_intersection==true){
        min_segment_length=100.*zoom;
        max_segment_length=200.*zoom;
        distance_node_factor=4.;
      }

      gamma=3.;
      Nbranches=6/zoom;
      vector<double> angles=nT.angle_range(11);
      if(MaxAngles<(int) angles.size()) angles.resize(MaxAngles);


      int cont=0;
      while(cont++<Nbranches){
        int Nnodes=nT.n_.size();
        min_segment_length*=node_radius_reduction_factor;
        max_segment_length*=node_radius_reduction_factor;
        min_radius*=node_radius_reduction_factor;
        max_radius*=node_radius_reduction_factor;
        average_radius*=node_radius_reduction_factor;
        if(min_radius<1. || min_segment_length<2.) break; //min_radius=1;
        distance_segment_factor/=node_radius_reduction_factor_sqrt;
        distance_node_factor/=node_radius_reduction_factor;

        nT.insert_nodes(
          Tinit,
          min_segment_length,max_segment_length,
          distance_segment_factor,
          min_radius,max_radius,
          distance_node_factor,
          smoothing_factor,
          type,
          gamma,
          1,// Nbranches,
          angles,
          MaxNnodes,
          MaxNeigbors,
          allow_branche_intersection
        );
        if(Nnodes==(int) nT.n_.size()) break;
      }

     min_radius=40.*zoom*average_radius/50.;max_radius=average_radius*zoom;
     distance_segment_factor=2./pow(node_radius_reduction_factor,6./zoom);
     distance_node_factor=3./pow(node_radius_reduction_factor,6./zoom);

     float smy=myrand(1.);
     distance_node_factor*=pow(node_radius_reduction_factor,1+5.*smy);
     distance_segment_factor*=pow(node_radius_reduction_factor,0.5+3.*smy);

     Nbranches=100000;
     if(allow_branche_intersection==true){
        min_segment_length=100.*zoom*pow(node_radius_reduction_factor,6./zoom);
        max_segment_length=250.*zoom*pow(node_radius_reduction_factor,6./zoom);
        distance_node_factor=3./pow(node_radius_reduction_factor,6./zoom);
      }
     gamma=4.;
     angles=nT.angle_range(13);
     if(MaxAngles<(int) angles.size()) angles.resize(MaxAngles);
//     while(true){
//        int Nnodes=nT.n_.size();
//        min_segment_length*=node_radius_reduction_factor;
//        max_segment_length*=node_radius_reduction_factor;
//        min_radius*=node_radius_reduction_factor;
//        max_radius*=node_radius_reduction_factor;
//        if(min_radius<1. || min_segment_length<2.) break; //min_radius=1;
//        distance_segment_factor/=node_radius_reduction_factor_sqrt;
//        distance_node_factor/=node_radius_reduction_factor;
//
//        nT.insert_nodes(
//          Tinit,
//          min_segment_length,max_segment_length,
//          distance_segment_factor,
//          min_radius,max_radius,
//          distance_node_factor,
//          smoothing_factor,
//          type,
//          gamma,
//          1,// Nbranches,
//          angles,
//          MaxNnodes,
//          3, //MaxNeigbors,
//          allow_branche_intersection
//        );
//        if(Nnodes==(int) nT.n_.size()) break;
//      }

      cont=0;
      if(allow_branche_intersection==true){
        distance_node_factor*=2.*pow(node_radius_reduction_factor,4);
      }
      while(true){
        cont++;
        int Nnodes=nT.n_.size();
        min_segment_length*=node_radius_reduction_factor;
        max_segment_length*=node_radius_reduction_factor;
        min_radius*=node_radius_reduction_factor;
        max_radius*=node_radius_reduction_factor;
        if(min_radius<1. || min_segment_length<2.) break; //min_radius=1;
        distance_segment_factor/=node_radius_reduction_factor_sqrt;
        distance_node_factor/=node_radius_reduction_factor;

        float gamma2=gamma;
        bool allow_branche_intersection2=false;
        float min_segment_length2=min_segment_length;
        float max_segment_length2=max_segment_length;
        float distance_node_factor2=distance_node_factor;
        if(cont%2==0 && allow_branche_intersection==true){
          gamma2=1.;
          allow_branche_intersection2=true;
          min_segment_length2=max_segment_length;
          max_segment_length2*=1.3;
          distance_node_factor2*=2*pow(node_radius_reduction_factor,4);
        }

        nT.insert_nodes(
          Tinit,
          min_segment_length2,
          max_segment_length2,
          distance_segment_factor,
          min_radius,max_radius,
          distance_node_factor2,
          smoothing_factor,
          type,
          gamma2,
          1,// Nbranches,
          angles,
          MaxNnodes,
          3,
          allow_branche_intersection2
        );
        if(Nnodes==(int) nT.n_.size()) break;
      }

     nT.joint_extrema(joint_extrema_probability);

     if(round_termination==false){
        for(unsigned int k=0;k<nT.n_.size();k++){
          if(nT.i_[k].size()==1) {
            nT.r_[k]=1;
            nT.s_[k]=0.1;
            nT.n_[k]=nT.n_[nT.i_[k][0]]+(nT.n_[k]-nT.n_[nT.i_[k][0]])*0.75;
          }
        }
      }
      nT.normalize();
  }

    ///-------------------------------------------------------------------------------------------------------
  /// MATISSE 10 BIS SEAWOOD 2
  else if(shape_type==7)
  {
      node_radius_reduction_factor=pow(node_radius_reduction_factor,0.5);

      /// BUILD A DECAGON TO CONSTRAINT THE SHAPE
      float T0y[5]={R0*sinf(2*M_PI/5),R0*sinf(M_PI/5),0,-R0*sinf(M_PI/5),-R0*sinf(2*M_PI/5)};
      float T0R[5]={R0*cosf(2*M_PI/5),R0*cosf(M_PI/5),R0,R0*cosf(M_PI/5),R0*cosf(2*M_PI/5)};
      Tinit=triangulation(point2d(512.,512.),T0y,T0R);

      nT.clear();
      nT.n_.push_back(point2d(512.,512.-0.9*R0));
      nT.i_.resize(1);
      nT.r_.push_back(zoom*average_radius);
      nT.s_.push_back(smoothing_factor);

      float min_segment_length=200.*zoom,max_segment_length=200.*zoom;
      float distance_segment_factor=2.;
      float min_radius=40.*zoom*average_radius/50.,max_radius=40*zoom*average_radius/50.;
      float distance_node_factor=4.;

      gamma=2.;
      vector<double> angles=nT.angle_range(7);
      if(MaxAngles<(int) angles.size()) angles.resize(MaxAngles);

      vector<int> posR(1,0);
      vector<int> posL(1,0);
      int direction=1.;
      while(true){
        int pos2=direction==1?posR[posR.size()-1]:posL[posL.size()-1];
        point2d  p;
        if(pos2==0) p=nT.n_[pos2]+point2d(90.*zoom*direction,(0.1+0.6*myrand(1.))*30.*zoom*average_radius/50.);
        else p=nT.n_[pos2]+point2d(90.*zoom*direction,(0.2+1.2*myrand(1.))*30.*zoom*average_radius/50.);
        if(Tinit.inclusion_test(p)<0){
          if(direction==-1) break;
          direction=-1;
          p=nT.n_[0]+point2d(90.*zoom*direction,(0.1+0.6*myrand(1.))*30.*zoom*average_radius/50.);
        }
        if(direction==1){
          nT.insert_point(p,40.*zoom*average_radius/50.,0.75,posR[posR.size()-1]);
          posR.push_back(nT.n_.size()-1);
        }
        else{
          nT.insert_point(p,40.*zoom*average_radius/50.,0.75,posL[posL.size()-1]);
          posL.push_back(nT.n_.size()-1);
        }

      }
      min_segment_length*=node_radius_reduction_factor;
      max_segment_length*=node_radius_reduction_factor;
      min_radius*=node_radius_reduction_factor;
      max_radius*=node_radius_reduction_factor;

      nT.insert_nodes(
          Tinit,
          min_segment_length,max_segment_length,
          distance_segment_factor,
          min_radius,max_radius,
          distance_node_factor,
          smoothing_factor,
          type,
          gamma,
          1,// Nbranches,
          angles,
          MaxNnodes,
          3,
          allow_branche_intersection
        );


      float length=0;
      while(true){
        length+=max_segment_length;
        if(length>600.) break;
        int Nnodes=nT.n_.size();
        min_segment_length*=node_radius_reduction_factor;
        max_segment_length*=node_radius_reduction_factor;
        min_radius*=node_radius_reduction_factor;
        max_radius*=node_radius_reduction_factor;
        if(min_radius<1. || min_segment_length<2.) break; //min_radius=1;
        distance_segment_factor/=node_radius_reduction_factor_sqrt;
        distance_node_factor/=node_radius_reduction_factor;

        nT.insert_nodes(
          Tinit,
          min_segment_length,max_segment_length,
          distance_segment_factor,
          min_radius,max_radius,
          distance_node_factor,
          smoothing_factor,
          type,
          gamma,
          1,// Nbranches,
          angles,
          MaxNnodes,
          2,
          allow_branche_intersection
        );
        if(Nnodes==(int) nT.n_.size()) break;
      }

      distance_node_factor*=3./2.;
      distance_segment_factor*=4./3.;
      float smy=myrand(1.);
      //smy=0.99;
      distance_node_factor*=pow(node_radius_reduction_factor,1+5.*smy);
      distance_segment_factor*=pow(node_radius_reduction_factor,0.5+3.*smy);

    angles=nT.angle_range(15);
    gamma=4.;
    if(MaxAngles<(int) angles.size()) angles.resize(MaxAngles);
//    while(true){
//        int Nnodes=nT.n_.size();
//        nT.insert_nodes(
//          Tinit,
//          min_segment_length,max_segment_length,
//          distance_segment_factor,
//          min_radius,max_radius,
//          distance_node_factor,
//          smoothing_factor,
//          1,//type,
//          gamma,
//          1,// Nbranches,
//          angles,
//          MaxNnodes,
//          4, //MaxNeigbors,
//          allow_branche_intersection,
//          0, //Symmetry
//          pow(node_radius_reduction_factor,2)
//        );
//        if(Nnodes==(int) nT.n_.size()) break;
//        min_segment_length*=node_radius_reduction_factor;
//        max_segment_length*=node_radius_reduction_factor;
//        min_radius*=node_radius_reduction_factor;
//        max_radius*=node_radius_reduction_factor;
//        if(min_radius<1. || min_segment_length<2.) break; //min_radius=1;
//        distance_segment_factor/=node_radius_reduction_factor_sqrt;
//        distance_node_factor/=node_radius_reduction_factor;
//      }

      int cont=0;
      if(allow_branche_intersection==true){
        distance_node_factor*=2.*pow(node_radius_reduction_factor,4);
      }
      while(true){
        cont++;
        int Nnodes=nT.n_.size();
        min_segment_length*=node_radius_reduction_factor;
        max_segment_length*=node_radius_reduction_factor;
        min_radius*=node_radius_reduction_factor;
        max_radius*=node_radius_reduction_factor;
        if(min_radius<1. || min_segment_length<2.) break; //min_radius=1;
        distance_segment_factor/=node_radius_reduction_factor_sqrt;
        distance_node_factor/=node_radius_reduction_factor;

        float gamma2=gamma;
        bool allow_branche_intersection2=false;
        float min_segment_length2=min_segment_length;
        float max_segment_length2=max_segment_length;
        float distance_node_factor2=distance_node_factor;
        if(cont%2==0 && allow_branche_intersection==true){
          gamma2=1.;
          allow_branche_intersection2=true;
          min_segment_length2=max_segment_length;
          max_segment_length2*=1.3;
          distance_node_factor2*=2*pow(node_radius_reduction_factor,4);
        }

        nT.insert_nodes(
          Tinit,
          min_segment_length2,
          max_segment_length2,
          distance_segment_factor,
          min_radius,max_radius,
          distance_node_factor2,
          smoothing_factor,
          1,//type,
          gamma2,
          1,// Nbranches,
          angles,
          MaxNnodes,
          4,
          allow_branche_intersection2
        );
        if(Nnodes==(int) nT.n_.size()) break;
      }



      for(unsigned int k=posL.size()-1;k>1;k--){
        if(nT.i_[posL[k]].size()==1) nT.erase_point(posL[k]);
      }
      for(unsigned int k=posR.size()-1;k>1;k--){
        if(nT.i_[posR[k]].size()==1) nT.erase_point(posR[k]);
      }

     nT.joint_extrema(joint_extrema_probability);

     if(round_termination==false){
        for(unsigned int k=0;k<nT.n_.size();k++){
          if(nT.i_[k].size()==1) {
            nT.r_[k]=1;
            nT.s_[k]=0.1;
            nT.n_[k]=nT.n_[nT.i_[k][0]]+(nT.n_[k]-nT.n_[nT.i_[k][0]])*0.75;
          }
        }
      }
      nT.normalize();
  }

  ///-------------------------------------------------------------------------------------------------------
  /// MATISSE 14 (SYMMETRY)
  else if(shape_type==8)
  {
      int SymmetryType=1+rand()%3;
      /// BUILD A DECAGON TO CONSTRAINT THE SHAPE
      float T0y[5]={R0*sinf(2*M_PI/5),R0*sinf(M_PI/5),0,-R0*sinf(M_PI/5),-R0*sinf(2*M_PI/5)};
      float T0R[5]={R0*cosf(2*M_PI/5),R0*cosf(M_PI/5),R0,R0*cosf(M_PI/5),R0*cosf(2*M_PI/5)};
      Tinit=triangulation(point2d(512.,512.),T0y,T0R);

      float min_segment_length=200.*zoom,max_segment_length=250.*zoom;
      while(true){
        point2d p(512.+(2.*myrand(1.)-1)*R0*0.5,512.+(2.*myrand(1.)-1)*R0*0.5);
        if(nT.InsideSymmetricRegion(p.x,p.y,512.,512.,SymmetryType)==false) continue;
        nT.point_line_projection(p,point2d(512.,512.),min_segment_length*0.5,SymmetryType);
        nT.n_.push_back(p);
        nT.i_.resize(1);
        nT.r_.push_back(50*1.5*zoom*average_radius/50.);
        nT.s_.push_back(smoothing_factor);
        break;
      }


      float distance_segment_factor=2.5;
      float min_radius=average_radius*zoom,max_radius=60*zoom*average_radius/50.;
      float distance_node_factor=5.;

      vector<double> angles=nT.angle_range(100);


      if(allow_branche_intersection==true){
        min_segment_length=200.*zoom;
        max_segment_length=250.*zoom;
        distance_node_factor=4.;
      }

      nT.insert_nodes(
        Tinit,
        min_segment_length,max_segment_length,
        distance_segment_factor,
        min_radius,max_radius,
        distance_node_factor,
        smoothing_factor,
        type,
        gamma,
        Nbranches,
        angles,
        MaxNnodes,
        MaxNeigbors,
        allow_branche_intersection,
        SymmetryType
     );

      //nT.print();
      if(myrand(1.)<0.5){
        for(unsigned int k=0;k<nT.n_.size();k++){
          if(nT.i_[k].size()==1) {
            nT.r_[k]=1;
            nT.s_[k]=0.1;
            nT.n_[k]=nT.n_[nT.i_[k][0]]+(nT.n_[k]-nT.n_[nT.i_[k][0]])*0.75;
          }
       }
      }


     if(round_termination==false){
        for(unsigned int k=0;k<nT.n_.size();k++){
          if(nT.i_[k].size()==1) {
            nT.r_[k]=1;
            nT.s_[k]=0.1;
            nT.n_[k]=nT.n_[nT.i_[k][0]]+(nT.n_[k]-nT.n_[nT.i_[k][0]])*0.75;
          }
        }
      }
  }
    ///-------------------------------------------------------------------------------------------------------
  /// MATISSE 15 PERIODICITY
  else if(shape_type==9)
  {

      int SymmetryType=4+rand()%3;
      zoom=average_node_distance*0.8; //0.1+myrand(1.)*0.9;
      dmin=128.;

      Tinit=triangulation(point2d(512.-dmin,512.-dmin), point2d(512.+dmin,512.+dmin));

      float min_segment_length=200.*zoom,max_segment_length=250.*zoom;
      if(smoothing_factor==0) max_segment_length=min_segment_length;
      while(true){
        point2d p(512.+dmin*myrand(1.),512.+dmin*myrand(1.));
        if(smoothing_factor==0.) p.y=p.x;
        if(nT.InsideSymmetricRegion(p.x,p.y,512.,512.,SymmetryType)==false) continue;
        nT.point_line_projection(p,point2d(512.,512.),min_segment_length*0.5,SymmetryType);
        nT.n_.push_back(p);
        nT.i_.resize(1);
        nT.r_.push_back(50*zoom*average_radius/50.);
        nT.s_.push_back(smoothing_factor);
        break;
      }


      float distance_segment_factor=2.5;
      float min_radius=average_radius*zoom,max_radius=average_radius*zoom;
      float distance_node_factor=5.;

      vector<double> angles=nT.angle_range(100);

      if(smoothing_factor==0){
        angles.clear();
        angles.push_back(0.);
        angles.push_back(M_PI/2);
        angles.push_back(M_PI);
        angles.push_back(3*M_PI/2);
        if(myrand(1.)<0.5){
          angles.push_back(M_PI/4);
          angles.push_back(3*M_PI/4);
          angles.push_back(5*M_PI/4);
          angles.push_back(7*M_PI/4);
        }
      }

      if(allow_branche_intersection==true){
        min_segment_length=200.*zoom;
        max_segment_length=250.*zoom;
        distance_node_factor=4.;
      }

      nT.insert_nodes(
        Tinit,
        min_segment_length,max_segment_length,
        distance_segment_factor,
        min_radius,max_radius,
        distance_node_factor,
        smoothing_factor,
        type,
        gamma,
        Nbranches,
        angles,
        MaxNnodes,
        MaxNeigbors,
        allow_branche_intersection,
        SymmetryType
     );

    for(unsigned int k=0;k<nT.n_.size();k++){
      nT.n_[k].x=512.+(nT.n_[k].x-512.)*4.;
      nT.n_[k].y=512.+(nT.n_[k].y-512.)*4.;
      nT.r_[k]=nT.r_[k]*4.;
    }

     nT.joint_extrema(joint_extrema_probability);

     if(round_termination==false){
        for(unsigned int k=0;k<nT.n_.size();k++){
          if(nT.i_[k].size()==1) {
            nT.r_[k]=1;
            nT.s_[k]=0.1;
            nT.n_[k]=nT.n_[nT.i_[k][0]]+(nT.n_[k]-nT.n_[nT.i_[k][0]])*0.75;
          }
        }
      }
  }
  ///-------------------------------------------------------------------------------------------------------
  /// SPIRAL
  else if(shape_type==10)
  {

      average_radius*=1.5;

      float step=16.;
      /// BUILD A DECAGON TO CONSTRAINT THE SHAPE
      float T0y[5]={R0*sinf(2*M_PI/5),R0*sinf(M_PI/5),0,-R0*sinf(M_PI/5),-R0*sinf(2*M_PI/5)};
      float T0R[5]={R0*cosf(2*M_PI/5),R0*cosf(M_PI/5),R0,R0*cosf(M_PI/5),R0*cosf(2*M_PI/5)};
      Tinit=triangulation(point2d(512.,512.),T0y,T0R);

      float r0=75.*zoom+(300-75.*zoom)*myrand(2.);  //25.;//2.*200.*zoom;
      point2d p0(512.+r0,512.);
      nT.n_.push_back(p0);
      nT.i_.resize(1);
      nT.r_.push_back(average_radius*zoom);
      nT.s_.push_back(smoothing_factor);

      int k;
      float zoom0=zoom;
      node_radius_reduction_factor=sqrt(node_radius_reduction_factor);
      for(k=1;k<=30000;k++){
        r0+=200.*zoom0/step;
        //point2d p(512.+(1.+k/16.)*200.*zoom*cos(2.*M_PI*k/16.),512.+(1.+k/16.)*200.*zoom*sin(2.*M_PI*k/16.));
         point2d p(512.+r0*cos(2.*M_PI*k/step),512.+r0*sin(2.*M_PI*k/step));
        if( Tinit.inclusion_test(p)<0) break;
        zoom*=node_radius_reduction_factor;
        float radius=average_radius*zoom;
        if(radius<1.) break;
        nT.insert_point(p,radius,smoothing_factor,nT.n_.size()-1);
      }
      nT.s_[nT.s_.size()-1]=0.01;
      r0-=1.5*200.*zoom0/step;
      point2d p(512.+r0*cos(2.*M_PI*(k-1.5)/step),512.+r0*sin(2.*M_PI*(k-1.5)/step));
      nT.insert_point(p,average_radius*zoom,smoothing_factor,nT.n_.size()-2,nT.n_.size()-1);

     if(round_termination==false){
        for(unsigned int k=0;k<nT.n_.size();k++){
          if(nT.i_[k].size()==1) {
            nT.r_[k]=1;
            nT.s_[k]=0.1;
            nT.n_[k]=nT.n_[nT.i_[k][0]]+(nT.n_[k]-nT.n_[nT.i_[k][0]])*0.75;
          }
        }
      }
      nT.normalize();
  }



  return nT;
}



/// **********************************************************
///               MAIN
/// **********************************************************
int main(int argc, char *argv[])
{
  /// EJEMPLO DE LLAMADA : exe  4 1 30. 50. 1. 0 1 1 0. 5 0 branched_shape.svg params.txt cat1024.bmp
  /// PARAMETERS
  /// argv[1] : branched shape type (integer) currently the potential values are from 0 to 10 (both included) (default value 0)
  /// argv[2] : initial random seed generator (unsigned int) range from 1 to 10000 (default value 1)
  /// argv[3] : average_node_distance (float) range from 15. to 300. (default value 150)
  /// argv[4] : average_radius (float) range from 1. to 100. (default value 50.)
  /// argv[5] : smoothing factor (float) range from 0. to 2. (default value 1.)
  /// argv[6] : branched_finished_in_peak (bool) (default value false)
  /// argv[7] : number of periodic loops in horizontal direction (int) range from 1 to 5 (default value 1)
  /// argv[8] : number of periodic loops in vertical direction (int) range from 1 to 5 (default value 1)
  /// argv[9] : joint_extrema_probability (float) range from 0. to 1. (default value 0.)
  /// argv[10] : Max size of node neighborhood (int) ranges from 2 to 20 (default value 5)
  /// argv[11] : Allow branche intersection (bool) (default value false)
  /// argv[12] : Reduction factor of branche width trough the branches (float) ranges from 0.8 to 1. (default value 1.)
  /// argv[13] : Max number of angles in a node neighborhood (int) ranges from 1 to 32 (default value 32)
  /// argv[14] : output file (the name of the svg file)
  /// argv[15] : output file (the name of the text file with the parameter values)
  /// argv[16] : initial silhouette (optional)



  /// MESSAGE STRING FOR "demo_failure.txt"
  char mes[300];

  srand(time(NULL)); rand();
  int shape_type=atoi(argv[1]); if(shape_type<0) shape_type=rand()%11;
  int random_seed=atoi(argv[2]); if(random_seed<0) random_seed=1+rand()%10000;
  float average_node_distance=atof(argv[3]); if(average_node_distance<0) average_node_distance=round(40.+myrand(1.5)*160.);
  float average_radius=atof(argv[4]); if(average_radius<0) average_radius=round(1.+myrand(1.)*99);
  float smoothing_factor=atof(argv[5]); if(smoothing_factor<0.) smoothing_factor=round(2.*myrand(1.)*10.)/10.;
  int temp=atoi(argv[6]);
  int branched_finished_in_peak = temp<0?(bool) (rand()%2):(bool) temp ;  //(bool) (atoi(argv[6])%2); //atoi(argv[6]); if(branched_finished_in_peak<0) branched_finished_in_peak=rand()%2;
  int Xperiods=atoi(argv[7]); if(Xperiods<0.) Xperiods=1+rand()%5;
  int Yperiods=atoi(argv[8]); if(Yperiods<0.) Yperiods=1+rand()%5;
  float joint_extrema_probability=atof(argv[9]); if(joint_extrema_probability<0.) joint_extrema_probability=round(myrand(1.)*10.)/10.;
  int MaxNeigbors=atoi(argv[10]); if(MaxNeigbors<0.) MaxNeigbors=2+rand()%10;
  temp=atoi(argv[11]);
  bool allow_branche_intersection = temp<0?(bool) (rand()%2):(bool) temp ; //(bool) (atoi(argv[11])%2);
  if(average_node_distance>=0 && average_node_distance<2 ) average_node_distance=2;
  if(average_radius>=0 && average_radius<1 ) average_radius=1;
  if(Xperiods==0) Xperiods=1;
  if(Yperiods==0) Yperiods=1;
  if(MaxNeigbors==0 || MaxNeigbors==1) MaxNeigbors=2;

//  if(atof(argv[3])<0 && average_node_distance<80 && shape_type!=9){
//    Xperiods=1;
//    Yperiods=1;
//  }
//  if(atof(argv[3])<0 && atof(argv[4])<0 && average_node_distance*0.5<average_radius){
//    average_radius=average_node_distance*0.5;
//  }
  float node_radius_reduction_factor=atof(argv[12]); if(node_radius_reduction_factor<0.) node_radius_reduction_factor=round(80.+20.*myrand(0.5))/100.;
  int MaxAngles=atoi(argv[13]); if(MaxAngles<0) MaxAngles=1+rand()%32;


  //if(average_radius>0.5*average_node_distance) average_radius=0.5*average_node_distance;

  FILE *f;
  f = fopen (argv[15],"w");
  if(f==NULL){
    sprintf(mes,"Problems reading params file %s\n",argv[15]);
    printf("%s\n",mes);
    fprintf_demo_failure(mes);
    return 2;
  }
  fprintf(f,"Parameter values used to create the branched shape:\n");
  fprintf(f,"shape type = %d\n",shape_type);
  fprintf(f,"random seed = %d\n",(int) random_seed);
  fprintf(f,"average node distance = %lf\n",average_node_distance);
  fprintf(f,"average width of branches = %lf\n",average_radius);
  fprintf(f,"smoothing factor = %lf\n",smoothing_factor);
  if(branched_finished_in_peak==true)
    fprintf(f,"branched finished in peak = %s\n","YES");
  else
    fprintf(f,"branched finished in peak = %s\n","NO");
  fprintf(f,"Number of rows in periodic pattern = %d\n",Xperiods);
  fprintf(f,"Number of lines in periodic pattern = %d\n",Yperiods);
  fprintf(f,"Probability to join extrema nodes = %lf\n",joint_extrema_probability);
  fprintf(f,"Max size of node neighborhood = %d\n",MaxNeigbors);
  if(allow_branche_intersection==true)
    fprintf(f,"allow branche intersection = %s\n","YES");
  else
    fprintf(f,"allow branche intersection  = %s\n","NO");
  fprintf(f,"Reduction factor of branche width across the branches = %lf\n",node_radius_reduction_factor);
  fprintf(f,"Max number of angles in a node neighborhood= %d\n",MaxAngles);
  if(argc<17)
    fprintf(f,"No silhouette has been included\n");
  else
    fprintf(f,"New silhouette included : %s\n",argv[16]);
  fclose(f);

  /*********************************** AAAAAA ****************************/
  #ifndef DEBUG
  {
    f = fopen ("params_temp.txt","w");
    if(f==NULL){
      sprintf(mes,"Problems reading params file %s\n","params_temp.txt");
      printf("%s\n",mes);
      fprintf_demo_failure(mes);
      return 2;
    }
    fprintf(f,"%d\n",shape_type);
    fprintf(f,"%d\n",(int) random_seed);
    fprintf(f,"%lf\n",average_node_distance);
    fprintf(f,"%lf\n",average_radius);
    fprintf(f,"%lf\n",smoothing_factor);
    fprintf(f,"%d\n",(int) branched_finished_in_peak);
    fprintf(f,"%d\n",Xperiods);
    fprintf(f,"%d\n",Yperiods);
    fprintf(f,"%lf\n",joint_extrema_probability);
    fprintf(f,"%d\n",MaxNeigbors);
    fprintf(f,"%d\n",(int) allow_branche_intersection);
    fprintf(f,"%lf\n",node_radius_reduction_factor);
    fprintf(f,"%d\n",MaxAngles);
    fclose(f);
  }
  #endif

  #ifdef DEBUG
  {
    f = fopen ("params_temp.txt","r");
    if(f==NULL){
      sprintf(mes,"Problems reading params file %s\n","params_temp.txt");
      printf("%s\n",mes);
      fprintf_demo_failure(mes);
      return 2;
    }
    int temp;
    fscanf(f,"%d\n",&shape_type);
    fscanf(f,"%d\n",&temp);
    random_seed = temp;
    fscanf(f,"%f\n",&average_node_distance);
    fscanf(f,"%f\n",&average_radius);
    fscanf(f,"%f\n",&smoothing_factor);
    fscanf(f,"%d\n",&temp);
    branched_finished_in_peak=(bool) temp;
    fscanf(f,"%d\n",&Xperiods);
    fscanf(f,"%d\n",&Yperiods);
    fscanf(f,"%f\n",&joint_extrema_probability);
    fscanf(f,"%d\n",&MaxNeigbors);
    fscanf(f,"%d\n",&temp);
    allow_branche_intersection=(bool) temp;
    fscanf(f,"%f\n",&node_radius_reduction_factor);
    fscanf(f,"%d\n",&MaxAngles);
    fclose(f);
  }
  #endif

  printf("Parameter values used to create the branched shape:\n");
  printf("shape type = %d\n",shape_type);
  printf("random seed = %d\n",(int) random_seed);
  printf("average node distance = %lf\n",average_node_distance);
  printf("average width of branches = %lf\n",average_radius);
  printf("smoothing factor = %lf\n",smoothing_factor);
  if(branched_finished_in_peak==true)
    printf("branched finished in peak = %s\n","YES");
  else
    printf("branched finished in peak = %s\n","NO");
  printf("Number of rows in periodic pattern = %d\n",Xperiods);
  printf("Number of lines in periodic pattern = %d\n",Yperiods);
  printf("Probability to join extrema nodes = %lf\n",joint_extrema_probability);
  printf("Max size of node neighborhood = %d\n",MaxNeigbors);
  if(allow_branche_intersection==true)
    printf("allow branche intersection = %s\n","YES");
  else
    printf("allow branche intersection  = %s\n","NO");
  printf("Reduction factor of branche width across the branches = %lf\n",node_radius_reduction_factor);
  printf("Max number of angles in a node neighborhood= %d\n",MaxAngles);
  if(argc<17)
    printf("No silhouette has been included\n");
  else
    printf("New silhouette included : %s\n",argv[16]);


  /// TRIANGULATION OF THE NEW SILHOUETTE (IF INCLUDED)
  triangulation Tinit;
  if(argc==17){
    printf("Silhouette BMP file = %s\n",argv[16]);
    imageBMP iBMP(argv[16]);
    //iBMP.write("prueba.bmp");
    if(iBMP.size()==0){
      sprintf(mes,"Problems reading silhouette image %s\n",argv[16]);
        printf("%s\n",mes);
        fprintf_demo_failure(mes);
        return 2;
    }
    int widthMaskBackground=iBMP.width();
    int heigthMaskBackground=iBMP.height();
    vector<float> If(iBMP.size());
    for(int k=0;k<(int) If.size();k++) If[k]=(float) .2126*iBMP[k].R_+.7152*iBMP[k].G_+.0722*iBMP[k].B_;
    printf("WE ZOOM, FILTER AND BINARIZE THE IMAGE INTENSITY\n");
    /*float ScaleRadius=*/zoom(If,widthMaskBackground,heigthMaskBackground,512.,1024.,2.,10.);
    printf("WE COMPUTE THE INITIAL TRIANGULATION\n");
    Tinit=triangulation(If,widthMaskBackground,heigthMaskBackground,1.,3,0.,0.86,1.);
    if(Tinit.p.size()<3 || Tinit.t.size()==0 ){
      sprintf(mes,"The silhouette can not be triangulated\n");
      printf("%s\n",mes);
      fprintf_demo_failure(mes);
      return 3;
    }
    vector<point2d> eV=Tinit.extrema();
    float xc=(eV[0].x+eV[1].x)/2;
    float yc=(eV[0].y+eV[1].y)/2;
    float scale=(eV[1].x-eV[0].x)/2;
    if(scale<( (eV[1].y-eV[0].y)/2)) scale=(eV[1].y-eV[0].y)/2;
    for(unsigned int k=0;k<Tinit.p.size();k++){
      Tinit.p[k].x=512.+512.*(Tinit.p[k].x-xc)/scale;
      Tinit.p[k].y=512.+512.*(Tinit.p[k].y-yc)/scale;
    }
  }
  #ifdef DEBUG
  printf("init BranchedShapeGenerator() \n");
  #endif
  NodeTree nT=BranchedShapeGenerator(
    Tinit,
    shape_type,
    random_seed,
    average_node_distance,
    average_radius,
    smoothing_factor,
    branched_finished_in_peak,
    joint_extrema_probability,
    MaxNeigbors,
    allow_branche_intersection,
    node_radius_reduction_factor,
    MaxAngles
  );
  #ifdef DEBUG
  printf("end BranchedShapeGenerator()\n");
  if(nT.checking()==false){
    printf("checking fails after  BranchedShapeGenerator()\n");
    return -1;
  }
  #endif


  if(Xperiods>1 || Yperiods>1){
    NodeTree nT0=nT;
    for(int i=0;i<Xperiods;i++){
      for(int j=0;j<Yperiods;j++){
        //printf("i=%d,j=%d\n",i,j);
        if(i==0 && j==0) continue;
        if(shape_type==9){
          nT.add( nT0.translation(point2d(1024.*i,1024.*j)) );
          continue;
        }
        //printf("average_radius=%lf, average_node_distance=%lf\n",average_radius,average_node_distance);
        NodeTree nT2=BranchedShapeGenerator(
            Tinit,
            shape_type,
            random_seed+i*Yperiods+j,
            average_node_distance,
            average_radius,
            smoothing_factor,
            branched_finished_in_peak,
            joint_extrema_probability,
            MaxNeigbors,
            allow_branche_intersection,
            node_radius_reduction_factor,
            MaxAngles
        );

        printf("i=%d, j=%d nT2.n_.size()=%d\n",i,j,(int) nT2.n_.size());
        if(nT2.checking()==false){
            sprintf(mes,"Problems computing the Branched shape. \nMaybe the average node distance is too large for this configuration or \nthe ratio between the average width of branches and the average node distance is too large.\n");
            printf("%s\n",mes);
            fprintf_demo_failure(mes);
            return -1;
        }

        nT.add( nT2.translation(point2d(1024.*i,1024.*j)) );
        if(nT.checking()==false){
            sprintf(mes,"Problems nT.add(). \n");
            printf("%s\n",mes);
            fprintf_demo_failure(mes);
            return -1;
        }
      }
    }
  }

  #ifdef DEBUG
  printf("CHECKING THE NodeTree\n");
  #endif
  if(nT.checking()==false){
    sprintf(mes,"Branched shape can not be built properly\n");
    printf("%s\n",mes);
    fprintf_demo_failure(mes);
    return 5;
  }

  #ifdef DEBUG
  printf("CHECKING IF THE SHAPE IS OUTSIDE 1024x1024\n");
  #endif
  if(nT.n_.size()>1){ //argc<17){
    vector<point2d> eV(2,nT.n_[0]);
    for(unsigned int k=0;k<nT.n_.size();k++){
      if( (nT.n_[k].x-2.*nT.r_[k])<eV[0].x ) eV[0].x=nT.n_[k].x-2.*nT.r_[k];
      if( (nT.n_[k].x+2.*nT.r_[k])>eV[1].x ) eV[1].x=nT.n_[k].x+2.*nT.r_[k];
      if( (nT.n_[k].y-2.*nT.r_[k])<eV[0].y ) eV[0].y=nT.n_[k].y-2.*nT.r_[k];
      if( (nT.n_[k].y+2.*nT.r_[k])>eV[1].y ) eV[1].y=nT.n_[k].y+2.*nT.r_[k];
    }
    //printf("\neV=(%lf,%lf),(%lf,%lf)\n",eV[0].x,eV[0].y,eV[1].x,eV[1].y);
    if(eV[0].x<24 || eV[0].y<24 || eV[1].x >1000 || eV[1].y >1000){
      float xc=(eV[0].x+eV[1].x)/2;
      float yc=(eV[0].y+eV[1].y)/2;
      float scale=(eV[1].x-eV[0].x)/2;
      if(scale<( (eV[1].y-eV[0].y)/2)) scale=(eV[1].y-eV[0].y)/2;
      scale=500./scale;
      for(unsigned int k=0;k<nT.n_.size();k++){
        nT.n_[k].x=512.+(nT.n_[k].x-xc)*scale;
        nT.n_[k].y=512.+(nT.n_[k].y-yc)*scale;
        nT.r_[k]=nT.r_[k]*scale;
     }
    }
  }

  #ifdef DEBUG
  printf("SAVING THE SHAPE IN SVG FORMAT\n");
  #endif
  if(branched_finished_in_peak==0 || shape_type!=1){
    nT.svg_generation(argv[14],true,argc,argv);
//    triangulation T=nT.triangulation_generation(10.,true);
//    (draw(nT,Tinit,T,true)).write("triangulation.png");
  }
  else{
    nT.svg_generation(argv[14],false,argc,argv);
//    triangulation T=nT.triangulation_generation(10.,false);
//    (draw(nT,Tinit,T,true)).write("triangulation.png");
  }

//  triangulation T=nT.triangulation_generation(10.,true);
//  (draw(nT,Tinit,T,true)).write("triangulation.png");
//  nT.print();



}
