#!/usr/bin/python

import os, sys
from PIL import Image
import json
import shutil
import hashlib
import random

def ensure_width(input_file, output_file):
    """
    if the witdh is not multiple of 4, correct it...
    """
    img = Image.open(input_file) 
    if (img.width % 4):
        new_width = int(round(img.width / 4) * 4)
        img.load()
        img2 = img.resize((new_width, img.height), Image.ANTIALIAS)
        img2.save(output_file)
        img2.close()
    img.close()

#-----------------------------------------------------------------------
if __name__ == '__main__':

    demoextras_path = sys.argv[1]
    select_shape = sys.argv[2]
    random_seed = sys.argv[3]
    average_node_distance = sys.argv[4]
    average_radius = sys.argv[5]
    smoothing_factor = sys.argv[6]
    branched_finished_in_peak = sys.argv[7]
    number_horizontal_loops = sys.argv[8]
    number_vertical_loops = sys.argv[9]
    joint_extrema_probability = sys.argv[10]
    max_size_node_neighborhood = sys.argv[11]
    allow_branche_intersection = sys.argv[12]
    reduction_factor = sys.argv[13] 
    max_number_of_angles = sys.argv[14]

    silhoutte = "input_0.bmp"
    output_file = "output.svg"
    outparams = "params.txt"

    if (os.path.exists(silhoutte)):
        ensure_width(silhoutte, silhoutte)
        with open("algo_info.txt","w") as algo_info:
            algo_info.write("sil='yes'")
        algo_info.close()
    else:    
        silhoutte = " "
        with open("algo_info.txt","w") as algo_info:
            algo_info.write("no_sil='yes'")
        algo_info.close() 

    string_for_execution = "{} {} {} {}".format(select_shape, random_seed, average_node_distance, average_radius)
    string_for_execution = "{} {} {}".format(string_for_execution, smoothing_factor, branched_finished_in_peak)
    string_for_execution = "{} {} {}".format(string_for_execution, number_horizontal_loops, number_vertical_loops)
    string_for_execution = "{} {} {}".format(string_for_execution, joint_extrema_probability, max_size_node_neighborhood)
    string_for_execution = "{} {} {}".format(string_for_execution, allow_branche_intersection, reduction_factor)
    string_for_execution = "{} {}".format(string_for_execution, max_number_of_angles)
    string_for_execution = "main {} {} {} {}".format(string_for_execution, output_file, outparams, silhoutte)
    os.system(string_for_execution)

    if not (os.path.exists(output_file)):
        if not (os.path.exists("demo_failure.txt")):
            error_message = "ERROR: There was a problem during the execution. The result file has not been obtained."
            with open("demo_failure.txt","w") as algo_info:
                algo_info.write(error_message)
            algo_info.close()

        os.system("echo -e '\n' >> demo_failure.txt") 
        if os.path.exists("params.txt"):    
            import fileinput
            outfilename = "demo_failure_aux.txt"
            filenames = ['demo_failure.txt', 'params.txt'] 
            with open(outfilename, 'w') as fout:
                for line in fileinput.input(filenames):
                    fout.write(line)
            os.rename(outfilename, 'demo_failure.txt')
        sys.exit(0)

    os.system("mogrify -format png output.svg")
    if os.path.exists(silhoutte):
        os.system("mogrify -format png input_0.bmp")


